/*************************************************************************/
/*                                                                       */
/*        Chopper.c - Built by Eric Lavillonniere on Tandon 386 - 89     */
/*                                                                       */
/*************************************************************************/
language config;

#include <stdio.h>
#include "token.h"
#include <sys/types.h>
#include <unistd.h>

#if !defined(SUN) || defined(LINUX)
#include <stdlib.h>/* #include "\meta\metachop\metachop.h"*/ 
#endif
/* #include "metachop.h" */ 

RIEN    DEBUT_EXT_CPLUS ;

#include "config.h"

RIEN    FIN_EXT_CPLUS ;

#include <fcntl.h>

config  *configParser ;
void    ChopTree (PTREE) ;
void    decomp () ;

extern "C" {
    PPTREE bri_parse_entry_config ( error_free )
    int error_free ;
    {
        return configParser -> langage(error_free);
    }
}

void    MetaInit () ;
void    MetaEnd () ;
extern PPTREE  (*the_parse_entry_pt)(int) ;
PTREE   ReadInFile () ;
extern int  firstError ;
extern char *includeEnv ;
char    *theLanguage = (char *)0 ;

main ( argc, argv )
int argc ;
char    **argv ;
{
    PTREE   tree ;
    char    name [50];
    char    *ptName ;
    
    MetaInit();
    includeEnv = getenv("INCLUDE");
    configParser = new config ;
    SwitchLang("config");
    if ( argc < 2 ) {
        sprintf(name, "Bad name for your source file \n");
        write(2, name, strlen(name));
        exit(0);
    } else {
        ptName = *(argv + 1);
        input = open(ptName, O_RDONLY | O_BINARY);
    }
    theLanguage = *(argv + 2);
    the_parse_entry_pt = bri_parse_entry_config ;
    tree = ReadInFile(0);
    AddRef(tree);
    ChopTree(tree);
    MetaEnd();
    if ( !firstError ) 
        return 1 ;
    else 
        return 0 ;
}

/********** when creating a tree chopper use the following ***************/
/*                                                                       */
/*  SwitchLang("metachop");                                              */
/*  return prog_metachop(1);                                             */
/*                                                                       */
/*************************************************************************/
/*************************************************************************/
/*   ChopTree : chop the tree : here call decomp                         */
/*************************************************************************/
void ChopTree ( tree )
PTREE   tree ;
{}/********** when creating a tree chopper use the following ***************/ /*                                                                       */ /*  decomp_metachop(tree) ;                                              */ /*                                                                       */ /*************************************************************************/ 

/*************************************************************************/
/*  decomp : display your program  : here dump tree                      */
/*************************************************************************/
void SqueezeMeta ( tree )
PTREE   tree ;
{}

void PullComment ( tree )
PTREE   tree ;
{}
