/*************************************************************************/
/*                                                                       */
/*        Chopper.c - Built by Eric Lavillonniere on Tandon 386 - 89     */
/*                                                                       */
/*************************************************************************/
language metab;

#include <stdio.h>
#include "token.h"
#include <stdio.h>
#include "token.h"
#include <sys/types.h>
#include <unistd.h>

#if !defined(SUN) || defined(LINUX)
#include <stdlib.h>
#endif

#include "metab.h"
#include "decmetab.h"
#include <fcntl.h>

static metab    *theParser ;
void            IChopTree (PTREE) ;
void            decomp (PTREE) ;
int             coutput, houtput ;
char            *thePath = (char *)0 ;

extern "C" {
    PTREE bri_parse_entry_metab ( int error_free )
    {
        return metab().parse_entry(error_free);
    }
    
    PTREE ChopTree ()
    {
        return (PTREE)0 ;
    }
    
    PTREE bri_parse_entry_metalang ( int error_free )
    {
        return (PTREE)0 ;
    }
    
    static  PPTREE getTree ( int error_free )
    {
        return metab().langage(error_free);
    }
    
    extern PPTREE   (*the_parse_entry_pt)(int) ;
    
    int VerifyFileLine ( int doit, char *llanguageName )
    {
        return 1 ;
    }
    
    int metaQuick, loutput ;
    
    void EcrireEntete ( char * ) {}
}

DecompMetab *DecompMetab::ptDecomp ;
extern char *theFileName ;

main ( int argc, char **argv )
{
    PTREE       tree ;
    char        name [50];
    char        *ptName ;
    DecompMetab decompMetab ;
    
    DecompMetab::ptDecomp = &decompMetab ;
    dumpCoord = 0 ;
    MetaInit();
    theParser = new metab ;
    SwitchLang("metab");
    if ( argc < 2 ) {
        sprintf(name, "Bad name for your source file \n");
        write(2, name, strlen(name));
        exit(0);
    } else {
        ptName = *(argv + 1);
        theFileName = ptName ;
        input = open(ptName, O_RDONLY | O_BINARY);
    }
    the_parse_entry_pt = getTree ;
    tree = ReadInFile(0);
    AddRef(tree);
    
    // si on a pas trouv la premire erreur dcompiler
    if ( firstError ) 
        IChopTree(tree);
    MetaEnd();
    
    // si on a dj eu une erreur renvoie code d'erreur
    if ( !firstError ) 
        return 1 ;
    else 
        return 0 ;
}

/*************************************************************************/
/*   IChopTree : chop the tree : here call decomp                         */
/*************************************************************************/
void        Treatment (PTREE) ;
extern void copy () ;

void IChopTree ( PTREE tree )
{
    copy();
    SwitchLang("metab");
    DecompMetab::ptDecomp -> Treat(tree);
    decomp_metab(tree);
    NewLine();
}
