#ifndef CPLUS_PARSER
#define CPLUS_PARSER

         extern int hasGotError;
        #include "interf.h"
    


#ifdef __cplusplus
#include "pretty.h"
typedef int (pretty::** _FUNC_MEMB_CPLUS) ();
class cplus: public pretty {
    public :
    
    static int init ; 
    
    cplus () {
        ptTokenArray = _tokenArray;
        ptTokenFuncArray =(_FUNC_MEMB_CPLUS) _tokenFuncArray;
        ptTokenNbFuncArray = _tokenNbFuncArray;
        InitConst ();
        keepCarriage = 0 ;
        keepAll = 0 ;
        
    }
    
    virtual void * rootGrammar () { return (void *) this;}
    virtual int Lex() ;
    virtual int LexComment() ;
    virtual int LexDefine() ;
    virtual int LexDefineName() ;
    virtual int LexEndLine() ;
    virtual int LexInclude() ;
    virtual int LexMeta() ;
    virtual int LexPragma() ;
    virtual int LexPragmaSmall() ;
    virtual int LexUndef() ;
    virtual int PushArgument() ;
    virtual int PushFunction() ;
    virtual PPTREE abstract_declarator ( int error_free) ;
    virtual PPTREE additive_expression ( int error_free) ;
    virtual PPTREE alloc_expression ( int error_free) ;
    virtual PPTREE allocation_expression ( int error_free) ;
    virtual PPTREE and_expression ( int error_free) ;
    virtual PPTREE arg_declarator ( int error_free) ;
    virtual PPTREE arg_typ_declarator ( int error_free) ;
    virtual PPTREE arg_typ_list ( int error_free) ;
    virtual PPTREE asm_declaration ( int error_free) ;
    virtual PPTREE assignment_end ( int error_free) ;
    virtual PPTREE assignment_expression ( int error_free) ;
    virtual PPTREE base_specifier ( int error_free) ;
    virtual PPTREE base_specifier_elem ( int error_free) ;
    virtual PPTREE bit_field_decl ( int error_free) ;
    virtual PPTREE cast_expression ( int error_free) ;
    virtual PPTREE cast_expression_value ( int error_free) ;
    virtual PPTREE catch_unit ( int error_free) ;
    virtual PPTREE catch_unit_ansi ( int error_free) ;
    virtual PPTREE class_declaration ( int error_free) ;
    virtual PPTREE comment_eater ( int error_free) ;
    virtual PPTREE complete_class_name ( int error_free) ;
    virtual PPTREE compound_statement ( int error_free) ;
    virtual PPTREE conditional_expression ( int error_free) ;
    virtual PPTREE const_or_volatile ( int error_free) ;
    virtual PPTREE constan ( int error_free) ;
    virtual PPTREE ctor_initializer ( int error_free) ;
    virtual PPTREE data_decl_exotic ( int error_free) ;
    virtual PPTREE data_decl_sc_decl ( int error_free) ;
    virtual PPTREE data_decl_sc_ty_decl ( int error_free) ;
    virtual PPTREE data_declaration ( int error_free) ;
    virtual PPTREE data_declaration_for ( int error_free) ;
    virtual PPTREE data_declaration_strict ( int error_free) ;
    virtual PPTREE deallocation_expression ( int error_free) ;
    virtual PPTREE declarator ( int error_free) ;
    virtual PPTREE declarator_follow ( int error_free) ;
    virtual PPTREE declarator_list ( int error_free) ;
    virtual PPTREE declarator_list_init ( int error_free) ;
    virtual PPTREE declarator_value ( int error_free) ;
    virtual PPTREE define_dir ( int error_free) ;
    virtual PPTREE directive ( int error_free) ;
    virtual PPTREE end_pragma ( int error_free) ;
    virtual PPTREE enum_val ( int error_free) ;
    virtual PPTREE equality_expression ( int error_free) ;
    virtual PPTREE exception ( int error_free) ;
    virtual PPTREE exception_ansi ( int error_free) ;
    virtual PPTREE exclusive_or_expression ( int error_free) ;
    virtual PPTREE expression ( int error_free) ;
    virtual PPTREE expression_for ( int error_free) ;
    virtual PPTREE ext_all ( int error_free) ;
    virtual PPTREE ext_all_ext ( int error_free) ;
    virtual PPTREE ext_all_no_linkage ( int error_free) ;
    virtual PPTREE ext_data_decl_sc_ty ( int error_free) ;
    virtual PPTREE ext_data_decl_simp ( int error_free) ;
    virtual PPTREE ext_data_declaration ( int error_free) ;
    virtual PPTREE ext_decl_dir ( int error_free) ;
    virtual PPTREE ext_decl_if_dir ( int error_free) ;
    virtual PPTREE ext_decl_ifdef_dir ( int error_free) ;
    virtual PPTREE func_declaration ( int error_free) ;
    virtual PPTREE func_declarator ( int error_free) ;
    virtual PPTREE ident_mul ( int error_free) ;
    virtual PPTREE include_dir ( int error_free) ;
    virtual PPTREE inclusive_or_expression ( int error_free) ;
    virtual PPTREE initializer ( int error_free) ;
    virtual PPTREE inside_declaration ( int error_free) ;
    virtual PPTREE inside_declaration1 ( int error_free) ;
    virtual PPTREE inside_declaration2 ( int error_free) ;
    virtual PPTREE label_beg ( int error_free) ;
    virtual PPTREE linkage_specification ( int error_free) ;
    virtual PPTREE logical_and_expression ( int error_free) ;
    virtual PPTREE logical_or_expression ( int error_free) ;
    virtual PPTREE long_short_int_char ( int error_free) ;
    virtual PPTREE macro ( int error_free) ;
    virtual PPTREE macro_extended ( int error_free) ;
    virtual PPTREE member_declarator ( int error_free) ;
    virtual PPTREE message_map ( int error_free) ;
    virtual PPTREE multiplicative_expression ( int error_free) ;
    virtual PPTREE new_1 ( int error_free) ;
    virtual PPTREE new_2 ( int error_free) ;
    virtual PPTREE new_declarator ( int error_free) ;
    virtual PPTREE new_type_name ( int error_free) ;
    virtual PPTREE operator_function_name ( int error_free) ;
    virtual PPTREE other_config ( int error_free) ;
    virtual PPTREE parameter_list ( int error_free) ;
    virtual PPTREE parameter_list_extended ( int error_free) ;
    virtual PPTREE parametrized_class ( int error_free) ;
    virtual PPTREE parse_entry ( int error_free) ;
    virtual PPTREE pm_expression ( int error_free) ;
    virtual PPTREE postfix_expression ( int error_free) ;
    virtual PPTREE primary_expression ( int error_free) ;
    virtual PPTREE program ( int error_free) ;
    virtual PPTREE protect_declare ( int error_free) ;
    virtual PPTREE ptr_operator ( int error_free) ;
    virtual PPTREE qualified_name ( int error_free) ;
    virtual PPTREE qualified_name_elem ( int error_free) ;
    virtual PPTREE quick_prog ( int error_free) ;
    virtual PPTREE quick_prog_elem ( int error_free) ;
    virtual PPTREE range_in_liste ( int error_free) ;
    virtual PPTREE range_modifier ( int error_free) ;
    virtual PPTREE range_modifier_function ( int error_free) ;
    virtual PPTREE range_modifier_ident ( int error_free) ;
    virtual PPTREE range_pragma ( int error_free) ;
    virtual PPTREE relational_expression ( int error_free) ;
    virtual PPTREE sc_specifier ( int error_free) ;
    virtual PPTREE shift_expression ( int error_free) ;
    virtual PPTREE simple_type ( int error_free) ;
    virtual PPTREE simple_type_name ( int error_free) ;
    virtual PPTREE sizeof_type ( int error_free) ;
    virtual int specific() ;
    virtual PPTREE stat_all ( int error_free) ;
    virtual PPTREE stat_dir ( int error_free) ;
    virtual PPTREE stat_if_dir ( int error_free) ;
    virtual PPTREE stat_ifdef_dir ( int error_free) ;
    virtual PPTREE statement ( int error_free) ;
    virtual PPTREE string_list ( int error_free) ;
    virtual PPTREE switch_elem ( int error_free) ;
    virtual PPTREE switch_list ( int error_free) ;
    virtual int the_exit() ;
    virtual PPTREE type_and_declarator ( int error_free) ;
    virtual PPTREE type_descr ( int error_free) ;
    virtual PPTREE type_name ( int error_free) ;
    virtual PPTREE type_specifier ( int error_free) ;
    virtual PPTREE type_specifier_without_param ( int error_free) ;
    virtual PPTREE typedef_and_declarator ( int error_free) ;
    virtual PPTREE unary_expression ( int error_free) ;
    
    
    int keepCarriage;
    int keepAll;
    static signed char * _tokenArray [123];
    static int (cplus::*(_tokenFuncArray [123])) ();
    static int _tokenNbFuncArray [123];

    virtual int SortKeyWord (int ret);
    virtual int UpSortKeyWord (int ret); 
    virtual void InitConst ();
    
    enum constants {
        BDECR =     302 ,
        BINCR =     301 ,
        ADDR =  300 ,
        NOT =   299 ,
        LNEG =  298 ,
        POS =   297 ,
        NEG =   296 ,
        STRING_LIST =   295 ,
        LABEL =     294 ,
        THROW_ANSI =    293 ,
        ELSE =  292 ,
        TUNSIGNED =     291 ,
        TSIGNED =   290 ,
        TIDENT =    289 ,
        TFLOAT =    288 ,
        TDOUBLE =   287 ,
        RSHI =  286 ,
        LSHI =  285 ,
        LT =    284 ,
        GT =    283 ,
        GEQU =  282 ,
        LEQU =  281 ,
        PROTECT_MEMB =  280 ,
        LANGUAGE =  279 ,
        EXP =   278 ,
        ADECR =     277 ,
        AINCR =     276 ,
        ARROW =     275 ,
        REF =   274 ,
        EXP_ARRAY =     273 ,
        EXP_LIST =  272 ,
        ARROW_MEMB =    271 ,
        DOT_MEMB =  270 ,
        POINETOI =  269 ,
        TIRESUPEETOI =  268 ,
        TIRESUPE =  267 ,
        SUPESUPE =  266 ,
        INFEINFE =  265 ,
        SUPEEGAL =  264 ,
        INFEEGAL =  263 ,
        NEW_DECLARATOR =    262 ,
        REM =   261 ,
        DIV =   260 ,
        MUL =   259 ,
        POURC =     258 ,
        MESSAGE_MAP =   257 ,
        MACRO =     256 ,
        TCHAR =     255 ,
        TSHORT =    254 ,
        TLONG =     253 ,
        TINT =  252 ,
        OR =    251 ,
        VBARVBAR =  250 ,
        AND =   249 ,
        ETCOETCO =  248 ,
        COMPOUND_EXT =  247 ,
        EXTERNAL =  246 ,
        INITIALIZER =   245 ,
        LOR =   244 ,
        VBAR =  243 ,
        FUNC =  242 ,
        STAT_VOID =     241 ,
        TEMPLATE_DECL =     240 ,
        CLASS_PARAM =   239 ,
        EXP_SEQ =   238 ,
        LXOR =  237 ,
        CHAP =  236 ,
        EXCEPTION_ANSI =    235 ,
        EXCEPTION =     234 ,
        NEQU =  233 ,
        EQU =   232 ,
        EXCLEGAL =  231 ,
        EGALEGAL =  230 ,
        PRAGMA =    229 ,
        INDENT_FUNCTION_TYPE =  228 ,
        COMMENT_PLUS =  227 ,
        COMMENT_END =   226 ,
        COMMENT_MIDDLE =    225 ,
        COMMENT_START =     224 ,
        MARGIN_VALUE =  223 ,
        BRACE_ALIGN_VALUE =     222 ,
        ASSIGN_ALIGN =  221 ,
        SINGLE_SWITCH_INDENT_VALUE =    220 ,
        SIMPLIFY_VALUE =    219 ,
        SIMPLIFY =  218 ,
        MODE_VALUE =    217 ,
        TAB_VALUE =     216 ,
        CONFIG =    215 ,
        NO_PRETTY =     214 ,
        ERROR =     213 ,
        UNDEF =     212 ,
        TYP_AFF_CALL =  211 ,
        MEMBER_DECLARATOR =     210 ,
        TYP_ARRAY =     209 ,
        CFER =  208 ,
        COUV =  207 ,
        FOR_DECLARATION =   206 ,
        DECLARATION =   205 ,
        CTOR_INITIALIZER =  204 ,
        CTOR_INIT =     203 ,
        IUN =   202 ,
        IUNLONG =   201 ,
        ILONG =     200 ,
        RANGE_MODIFIER =    199 ,
        COND_AFF =  198 ,
        INTE =  197 ,
        COMPOUND =  196 ,
        PARAM_TYPE =    195 ,
        SUPE =  194 ,
        INFE =  193 ,
        CLASS_DECL =    192 ,
        AFER =  191 ,
        CATCH_ANSI =    190 ,
        EXCEPT_ANSI_ALL =   189 ,
        CAST =  188 ,
        DPOI =  187 ,
        TYP_BIT =   186 ,
        PROTECT =   185 ,
        BASE_LIST =     184 ,
        XOR_AFF =   183 ,
        OR_AFF =    182 ,
        AND_AFF =   181 ,
        RSH_AFF =   180 ,
        LSH_AFF =   179 ,
        MIN_AFF =   178 ,
        PLU_AFF =   177 ,
        REM_AFF =   176 ,
        DIV_AFF =   175 ,
        MUL_AFF =   174 ,
        AFF =   173 ,
        POINPOINPOIN =  172 ,
        VAR_LIST =  171 ,
        TYP_LIST =  170 ,
        TYP_AFF =   169 ,
        ABST_DECLARATOR =   168 ,
        DECLARATOR =    167 ,
        LAND =  166 ,
        INIT_NEW =  165 ,
        VIRG =  164 ,
        QUALIFIED =     163 ,
        MINUS =     162 ,
        TYP =   161 ,
        PFER =  160 ,
        DESTRUCT =  159 ,
        TYP_REF =   158 ,
        TYP_ADDR =  157 ,
        DEFAULT =   156 ,
        CASE =  155 ,
        THROW =     154 ,
        FORALLSONS =    153 ,
        WHILE =     152 ,
        SWITCH =    151 ,
        RETURN =    150 ,
        IF =    149 ,
        FOR =   148 ,
        DO =    147 ,
        CONTINUE =  146 ,
        BREAK =     145 ,
        PVIR =  144 ,
        TYPEDEF =   143 ,
        TEMPLATE =  142 ,
        TRY =   141 ,
        EXTERN =    140 ,
        STATIC =    139 ,
        AUTO =  138 ,
        AOUV =  137 ,
        CATCH =     136 ,
        PUBLIC =    135 ,
        PROTECTED =     134 ,
        PRIVATE =   133 ,
        CHAPEGAL =  132 ,
        VBAREGAL =  131 ,
        ETCOEGAL =  130 ,
        SUPESUPEEGAL =  129 ,
        INFEINFEEGAL =  128 ,
        TIREEGAL =  127 ,
        PLUSEGAL =  126 ,
        POURCEGAL =     125 ,
        ETOIEGAL =  124 ,
        EGAL =  123 ,
        ASM =   122 ,
        CLASS =     121 ,
        UNION =     120 ,
        STRUCT =    119 ,
        ENUM =  118 ,
        CONST =     117 ,
        FRIEND =    116 ,
        VIRTUAL =   115 ,
        INLINE =    114 ,
        REGISTER =  113 ,
        VOLATILE =  112 ,
        SHORT =     111 ,
        UNSIGNED =  110 ,
        SIGNED =    109 ,
        LONG =  108 ,
        VOID =  107 ,
        CHAR =  106 ,
        INT =   105 ,
        DOUBLE =    104 ,
        VA_ARG =    103 ,
        OPERATOR =  102 ,
        DELETE =    101 ,
        NEW =   100 ,
        DPOIDPOI =  99 ,
        SIZEOF =    98 ,
        TIRETIRE =  97 ,
        PLUSPLUS =  96 ,
        ETCO =  95 ,
        ETOI =  94 ,
        EXCL =  93 ,
        TILD =  92 ,
        PLUS =  91 ,
        TIRE =  90 ,
        POUV =  89 ,
        FUNC_SPEC =     88 ,
        TRY_UPPER =     87 ,
        END_CATCH =     86 ,
        END_CATCH_ALL =     85 ,
        AND_CATCH =     84 ,
        CATCH_UPPER =   83 ,
        CATCH_ALL =     82 ,
        END_MESSAGE_MAP =   81 ,
        BEGIN_MESSAGE_MAP =     80 ,
        DECLARE_MESSAGE_MAP =   79 ,
        IMPLEMENT_SERIAL =  78 ,
        IMPLEMENT_DYNCREATE =   77 ,
        IMPLEMENT_DYNAMIC =     76 ,
        DECLARE_SERIAL =    75 ,
        DECLARE_DYNAMIC =   74 ,
        PUSH_FUNCTION =     73 ,
        PUSH_ARGUMENT =     72 ,
        UNDEF_CONTENT =     71 ,
        SMALL_PRAGMA_CONTENT =  70 ,
        PRAGMA_CONTENT =    69 ,
        PRAGMA_INDENT_FUNCTION_TYPE =   68 ,
        PRAGMA_COMMENT_PLUS =   67 ,
        PRAGMA_COMMENT_END =    66 ,
        PRAGMA_COMMENT_MIDDLE =     65 ,
        PRAGMA_COMMENT_START =  64 ,
        PRAGMA_MARGIN =     63 ,
        PRAGMA_ASSIGN_ALIGN =   62 ,
        PRAGMA_SINGLE_SWITCH_INDENT =   61 ,
        PRAGMA_SIMPLIFY =   60 ,
        PRAGMA_BRACE_ALIGN =    59 ,
        PRAGMA_MODE =   58 ,
        PRAGMA_RANGE =  57 ,
        PRAGMA_TAB =    56 ,
        PRAGMA_CONFIG =     55 ,
        PRAGMA_NOPRETTY =   54 ,
        PRAGMA_PRETTY =     53 ,
        INCLUDE_LOCAL =     52 ,
        INCLUDE_SYS =   51 ,
        END_LINE =  50 ,
        DEFINE_NAME =   49 ,
        DEFINED_NOT_CONTINUED =     48 ,
        DEFINED_CONTINUED =     47 ,
        POINT =     46 ,
        SLAS =  45 ,
        SLASEGAL =  44 ,
        CARRIAGE_RETURN =   43 ,
        UNDEF_DIR =     42 ,
        DEFINE_DIR =    41 ,
        ERROR_DIR =     40 ,
        PRAGMA_DIR =    39 ,
        LINE_DIR =  38 ,
        ENDIF_DIR =     37 ,
        ELIF_DIR =  36 ,
        ELSE_DIR =  35 ,
        IF_DIR =    34 ,
        IFNDEF_DIR =    33 ,
        IFDEF_DIR =     32 ,
        INCLUDE_DIR =   31 ,
        OCTAL =     30 ,
        UOCTAL =    29 ,
        LOCTAL =    28 ,
        ULOCTAL =   27 ,
        HEXA =  26 ,
        UHEXA =     25 ,
        LHEXA =     24 ,
        ULHEXA =    23 ,
        INTEGER =   22 ,
        FLOAT =     21 ,
        UINTEGER =  20 ,
        LINTEGER =  19 ,
        ULINTEGER =     18 ,
        CHARACT =   17 ,
        STRING =    16 ,
        IDENT =     15 ,
        GOTO_REL =  14 ,
        GOTO =  13 ,
        STR =   12 ,
        UNMARK =    11 ,
        MARK =  10 ,
        TAB_VIRT =  9 ,
        TAB =   8 ,
        NEWLINE =   7 ,
        ATTRIBUTS =     6 ,
        PLACE_HOLD_CONST
    } ; 
} ; 

extern cplus * parser_cplus;

#endif
#define BDECR_cplus     302
#define BINCR_cplus     301
#define ADDR_cplus  300
#define NOT_cplus   299
#define LNEG_cplus  298
#define POS_cplus   297
#define NEG_cplus   296
#define STRING_LIST_cplus   295
#define LABEL_cplus     294
#define THROW_ANSI_cplus    293
#define ELSE_cplus  292
#define TUNSIGNED_cplus     291
#define TSIGNED_cplus   290
#define TIDENT_cplus    289
#define TFLOAT_cplus    288
#define TDOUBLE_cplus   287
#define RSHI_cplus  286
#define LSHI_cplus  285
#define LT_cplus    284
#define GT_cplus    283
#define GEQU_cplus  282
#define LEQU_cplus  281
#define PROTECT_MEMB_cplus  280
#define LANGUAGE_cplus  279
#define EXP_cplus   278
#define ADECR_cplus     277
#define AINCR_cplus     276
#define ARROW_cplus     275
#define REF_cplus   274
#define EXP_ARRAY_cplus     273
#define EXP_LIST_cplus  272
#define ARROW_MEMB_cplus    271
#define DOT_MEMB_cplus  270
#define POINETOI_cplus  269
#define TIRESUPEETOI_cplus  268
#define TIRESUPE_cplus  267
#define SUPESUPE_cplus  266
#define INFEINFE_cplus  265
#define SUPEEGAL_cplus  264
#define INFEEGAL_cplus  263
#define NEW_DECLARATOR_cplus    262
#define REM_cplus   261
#define DIV_cplus   260
#define MUL_cplus   259
#define POURC_cplus     258
#define MESSAGE_MAP_cplus   257
#define MACRO_cplus     256
#define TCHAR_cplus     255
#define TSHORT_cplus    254
#define TLONG_cplus     253
#define TINT_cplus  252
#define OR_cplus    251
#define VBARVBAR_cplus  250
#define AND_cplus   249
#define ETCOETCO_cplus  248
#define COMPOUND_EXT_cplus  247
#define EXTERNAL_cplus  246
#define INITIALIZER_cplus   245
#define LOR_cplus   244
#define VBAR_cplus  243
#define FUNC_cplus  242
#define STAT_VOID_cplus     241
#define TEMPLATE_DECL_cplus     240
#define CLASS_PARAM_cplus   239
#define EXP_SEQ_cplus   238
#define LXOR_cplus  237
#define CHAP_cplus  236
#define EXCEPTION_ANSI_cplus    235
#define EXCEPTION_cplus     234
#define NEQU_cplus  233
#define EQU_cplus   232
#define EXCLEGAL_cplus  231
#define EGALEGAL_cplus  230
#define PRAGMA_cplus    229
#define INDENT_FUNCTION_TYPE_cplus  228
#define COMMENT_PLUS_cplus  227
#define COMMENT_END_cplus   226
#define COMMENT_MIDDLE_cplus    225
#define COMMENT_START_cplus     224
#define MARGIN_VALUE_cplus  223
#define BRACE_ALIGN_VALUE_cplus     222
#define ASSIGN_ALIGN_cplus  221
#define SINGLE_SWITCH_INDENT_VALUE_cplus    220
#define SIMPLIFY_VALUE_cplus    219
#define SIMPLIFY_cplus  218
#define MODE_VALUE_cplus    217
#define TAB_VALUE_cplus     216
#define CONFIG_cplus    215
#define NO_PRETTY_cplus     214
#define ERROR_cplus     213
#define UNDEF_cplus     212
#define TYP_AFF_CALL_cplus  211
#define MEMBER_DECLARATOR_cplus     210
#define TYP_ARRAY_cplus     209
#define CFER_cplus  208
#define COUV_cplus  207
#define FOR_DECLARATION_cplus   206
#define DECLARATION_cplus   205
#define CTOR_INITIALIZER_cplus  204
#define CTOR_INIT_cplus     203
#define IUN_cplus   202
#define IUNLONG_cplus   201
#define ILONG_cplus     200
#define RANGE_MODIFIER_cplus    199
#define COND_AFF_cplus  198
#define INTE_cplus  197
#define COMPOUND_cplus  196
#define PARAM_TYPE_cplus    195
#define SUPE_cplus  194
#define INFE_cplus  193
#define CLASS_DECL_cplus    192
#define AFER_cplus  191
#define CATCH_ANSI_cplus    190
#define EXCEPT_ANSI_ALL_cplus   189
#define CAST_cplus  188
#define DPOI_cplus  187
#define TYP_BIT_cplus   186
#define PROTECT_cplus   185
#define BASE_LIST_cplus     184
#define XOR_AFF_cplus   183
#define OR_AFF_cplus    182
#define AND_AFF_cplus   181
#define RSH_AFF_cplus   180
#define LSH_AFF_cplus   179
#define MIN_AFF_cplus   178
#define PLU_AFF_cplus   177
#define REM_AFF_cplus   176
#define DIV_AFF_cplus   175
#define MUL_AFF_cplus   174
#define AFF_cplus   173
#define POINPOINPOIN_cplus  172
#define VAR_LIST_cplus  171
#define TYP_LIST_cplus  170
#define TYP_AFF_cplus   169
#define ABST_DECLARATOR_cplus   168
#define DECLARATOR_cplus    167
#define LAND_cplus  166
#define INIT_NEW_cplus  165
#define VIRG_cplus  164
#define QUALIFIED_cplus     163
#define MINUS_cplus     162
#define TYP_cplus   161
#define PFER_cplus  160
#define DESTRUCT_cplus  159
#define TYP_REF_cplus   158
#define TYP_ADDR_cplus  157
#define DEFAULT_cplus   156
#define CASE_cplus  155
#define THROW_cplus     154
#define FORALLSONS_cplus    153
#define WHILE_cplus     152
#define SWITCH_cplus    151
#define RETURN_cplus    150
#define IF_cplus    149
#define FOR_cplus   148
#define DO_cplus    147
#define CONTINUE_cplus  146
#define BREAK_cplus     145
#define PVIR_cplus  144
#define TYPEDEF_cplus   143
#define TEMPLATE_cplus  142
#define TRY_cplus   141
#define EXTERN_cplus    140
#define STATIC_cplus    139
#define AUTO_cplus  138
#define AOUV_cplus  137
#define CATCH_cplus     136
#define PUBLIC_cplus    135
#define PROTECTED_cplus     134
#define PRIVATE_cplus   133
#define CHAPEGAL_cplus  132
#define VBAREGAL_cplus  131
#define ETCOEGAL_cplus  130
#define SUPESUPEEGAL_cplus  129
#define INFEINFEEGAL_cplus  128
#define TIREEGAL_cplus  127
#define PLUSEGAL_cplus  126
#define POURCEGAL_cplus     125
#define ETOIEGAL_cplus  124
#define EGAL_cplus  123
#define ASM_cplus   122
#define CLASS_cplus     121
#define UNION_cplus     120
#define STRUCT_cplus    119
#define ENUM_cplus  118
#define CONST_cplus     117
#define FRIEND_cplus    116
#define VIRTUAL_cplus   115
#define INLINE_cplus    114
#define REGISTER_cplus  113
#define VOLATILE_cplus  112
#define SHORT_cplus     111
#define UNSIGNED_cplus  110
#define SIGNED_cplus    109
#define LONG_cplus  108
#define VOID_cplus  107
#define CHAR_cplus  106
#define INT_cplus   105
#define DOUBLE_cplus    104
#define VA_ARG_cplus    103
#define OPERATOR_cplus  102
#define DELETE_cplus    101
#define NEW_cplus   100
#define DPOIDPOI_cplus  99
#define SIZEOF_cplus    98
#define TIRETIRE_cplus  97
#define PLUSPLUS_cplus  96
#define ETCO_cplus  95
#define ETOI_cplus  94
#define EXCL_cplus  93
#define TILD_cplus  92
#define PLUS_cplus  91
#define TIRE_cplus  90
#define POUV_cplus  89
#define FUNC_SPEC_cplus     88
#define TRY_UPPER_cplus     87
#define END_CATCH_cplus     86
#define END_CATCH_ALL_cplus     85
#define AND_CATCH_cplus     84
#define CATCH_UPPER_cplus   83
#define CATCH_ALL_cplus     82
#define END_MESSAGE_MAP_cplus   81
#define BEGIN_MESSAGE_MAP_cplus     80
#define DECLARE_MESSAGE_MAP_cplus   79
#define IMPLEMENT_SERIAL_cplus  78
#define IMPLEMENT_DYNCREATE_cplus   77
#define IMPLEMENT_DYNAMIC_cplus     76
#define DECLARE_SERIAL_cplus    75
#define DECLARE_DYNAMIC_cplus   74
#define PUSH_FUNCTION_cplus     73
#define PUSH_ARGUMENT_cplus     72
#define UNDEF_CONTENT_cplus     71
#define SMALL_PRAGMA_CONTENT_cplus  70
#define PRAGMA_CONTENT_cplus    69
#define PRAGMA_INDENT_FUNCTION_TYPE_cplus   68
#define PRAGMA_COMMENT_PLUS_cplus   67
#define PRAGMA_COMMENT_END_cplus    66
#define PRAGMA_COMMENT_MIDDLE_cplus     65
#define PRAGMA_COMMENT_START_cplus  64
#define PRAGMA_MARGIN_cplus     63
#define PRAGMA_ASSIGN_ALIGN_cplus   62
#define PRAGMA_SINGLE_SWITCH_INDENT_cplus   61
#define PRAGMA_SIMPLIFY_cplus   60
#define PRAGMA_BRACE_ALIGN_cplus    59
#define PRAGMA_MODE_cplus   58
#define PRAGMA_RANGE_cplus  57
#define PRAGMA_TAB_cplus    56
#define PRAGMA_CONFIG_cplus     55
#define PRAGMA_NOPRETTY_cplus   54
#define PRAGMA_PRETTY_cplus     53
#define INCLUDE_LOCAL_cplus     52
#define INCLUDE_SYS_cplus   51
#define END_LINE_cplus  50
#define DEFINE_NAME_cplus   49
#define DEFINED_NOT_CONTINUED_cplus     48
#define DEFINED_CONTINUED_cplus     47
#define POINT_cplus     46
#define SLAS_cplus  45
#define SLASEGAL_cplus  44
#define CARRIAGE_RETURN_cplus   43
#define UNDEF_DIR_cplus     42
#define DEFINE_DIR_cplus    41
#define ERROR_DIR_cplus     40
#define PRAGMA_DIR_cplus    39
#define LINE_DIR_cplus  38
#define ENDIF_DIR_cplus     37
#define ELIF_DIR_cplus  36
#define ELSE_DIR_cplus  35
#define IF_DIR_cplus    34
#define IFNDEF_DIR_cplus    33
#define IFDEF_DIR_cplus     32
#define INCLUDE_DIR_cplus   31
#define OCTAL_cplus     30
#define UOCTAL_cplus    29
#define LOCTAL_cplus    28
#define ULOCTAL_cplus   27
#define HEXA_cplus  26
#define UHEXA_cplus     25
#define LHEXA_cplus     24
#define ULHEXA_cplus    23
#define INTEGER_cplus   22
#define FLOAT_cplus     21
#define UINTEGER_cplus  20
#define LINTEGER_cplus  19
#define ULINTEGER_cplus     18
#define CHARACT_cplus   17
#define STRING_cplus    16
#define IDENT_cplus     15
#define GOTO_REL_cplus  14
#define GOTO_cplus  13
#define STR_cplus   12
#define UNMARK_cplus    11
#define MARK_cplus  10
#define TAB_VIRT_cplus  9
#define TAB_cplus   8
#define NEWLINE_cplus   7
#define ATTRIBUTS_cplus     6
#undef _Tak
#define _Tak(func) func 
#endif
